/*****************************************************************************
 * main.c
 *****************************************************************************/

#include "main.h"

#include <sys/platform.h>
#include <sys/adi_core.h>
#include "adi_initialize.h"
#include <stdio.h>
#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>
void ConfigSoftSwitches_EV_SOM(void);
void ConfigSoftSwitches_EVAL_EZKIT_SOM(void);
#if defined(__ADSPSC598_FAMILY__)

#endif
int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause) ;


#define ECDSA256
#define KEY_SIZE 64
#define Blp
#define DMC_INIT


#ifdef ECDSA224
uint8_t PublicKey[] = {
    /* the Qx value */
    0x54, 0x79, 0xab, 0x3b,
    0xc4, 0x56, 0x08, 0x06,
    0x32, 0xe6, 0xf7, 0x83,
    0xed, 0xb9, 0xf6, 0xb9,
    0x68, 0x61, 0xea, 0xe7,
    0x36, 0x47, 0x8b, 0x91,
    0xd7, 0xfd, 0x46, 0xa4,
	0x00,0x00,0x00,0x00,

    /* the Qy value */
    0x97, 0xa5, 0x6d, 0x4b,
    0xe5, 0x45, 0x85, 0xa5,
    0x9a, 0x56, 0x8d, 0x83,
    0x09, 0xe3, 0x5f, 0x80,
    0xe1, 0x5e, 0x8c, 0x89,
    0x16, 0xb9, 0x57, 0x09,
    0xd5, 0x8e, 0xf6, 0xf1, /*CORRECT KEY*/
    //0xd5, 0x8e, 0xf6, 0xff,	/*INCORRECT KEY*/
	0x00,0x00,0x00,0x00
};
#endif
#ifdef ECDSA256
uint8_t PublicKey[] = {
    /* the Qx value */
    0x31, 0x14, 0x7d, 0xd3,
    0x76, 0x37, 0xc3, 0xd3,
    0x91, 0x00, 0x26, 0x31,
    0xed, 0x29, 0x88, 0xd0,
    0x4b, 0xa6, 0xb5, 0x69,
    0xb3, 0xbf, 0x7b, 0x4c,
    0x6b, 0xd9, 0x0f, 0x10,
    0x3e, 0xd5, 0x44, 0xa5,

    /* the Qy value */
    0xc8, 0xe1, 0xab, 0x1e,
    0x83, 0x9e, 0x2d, 0xdb,
    0xcb, 0x72, 0x75, 0x02,
    0x9a, 0xba, 0x51, 0x3a,
    0x85, 0x4b, 0x3d, 0xe4,
    0x8c, 0x0f, 0x7f, 0x98,
    0xa8, 0x7c, 0x3a, 0x38,
    0x89, 0x8b, 0x6a, 0x82 //correct
    //0x49, 0x8b, 0x6a, 0x82 //wrong

};
#endif
#ifdef Blx
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/
		//0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0x3a /*wrong key*/
};
#endif
#ifdef Blw
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/
		//0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0x3a /*wrong key*/
};
uint8_t AESwrapKey[]={
		0xBE,0x63,0xF3,0xC8,0X88,0X97,0XF5,0X6F,0X50,0X2D,0X23,0X97,0XD9,0X90,0X3E,0X39 /*correct key*/
		//0xBA,0x63,0xF3,0xC8,0X88,0X97,0XF5,0X6F,0X50,0X2D,0X23,0X97,0XD9,0X90,0X3E,0X39 /*wrong key*/
};
#endif

char __argv_string[] = "";
uint32_t BootCmd=0;
//void adi_mmu_Init();

ADI_ROM_OTP_BOOT_CGU_INFO cgu_config;
int result = 0;

int main()
{
	adi_initComponents();

	uint32_t BootCmd=0;

#ifdef DMC_INIT
	/*Initialize Power Service*/
	result = (uint32_t)adi_pwr_Init((uint8_t)ADI_PWR_CGU0, (uint32_t)CLKIN);
	if(result != 0)
	{
		printf("PWR Init Failed\n");
	}

	/* Set DMC Lane Reset */
	adi_dmc_lane_reset(true);

	/* Initialize CGU and CDU */
	result = (uint32_t)adi_pwr_cfg0_init();
	if(result != 0)
	{
		printf("PWR Config Failed\n");
	}

	/* Clear DMC Lane Reset */
	adi_dmc_lane_reset(false);

	/* Initialize DMC */
	result = adi_dmc_cfg0_init();
	if(result != 0)
	{
		printf("DMC Config Failed\n");
	}
#endif

	/********Softconfig Part****************/
	/* Configure the Pin MUX for TWI2 for SoftConfig */
	//*pREG_PORTA_MUX = 0x0;
	//*pREG_PORTA_FER_SET = BITM_PORT_FER_PX14 | BITM_PORT_FER_PX15;
	/*SoftConfig for SOM SC598*/
	//ConfigSoftSwitches_EV_SC598_SOM();
	/********Softconfig Part****************/

	/*Tuning enabled*/
	*pREG_PADS0_PCFG0 |=(1<<21);
	*pREG_PADS0_PCFG1|=(4<<28);

	/*SPU config eMSI*/
	*pREG_SPU0_SECUREP175 = 0x3;

	/***********************************Safe Boot*********************************/
	//1 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_1BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR|BITM_ROM_BCMD_EMSI_SAFEBOOT;

	//4 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_4BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR|BITM_ROM_BCMD_EMSI_SAFEBOOT;

	//8 Bit SDR
	BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_8BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR|BITM_ROM_BCMD_EMSI_SAFEBOOT;

	//4 Bit DDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_4BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_DDR|BITM_ROM_BCMD_EMSI_SAFEBOOT;

	//8 Bit DDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_8BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_DDR|BITM_ROM_BCMD_EMSI_SAFEBOOT;

	/********************************************************Safe Boot*********************************************************************************/


	/********************************Default Boot*********************************************************************************/
	//1 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_1BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR;

	//4 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_4BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR;

	//8 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_8BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR;

	//4 Bit DDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_4BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_DDR;

	//8 Bit DDR
    //BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_8BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_DDR;

	/********************************************************Default Boot*********************************************************************************/


	/*************************************************Boot Area***********************************************************************/
	//1 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_1BIT |BITM_ROM_BCMD_EMSI_HISPEEDENABLE |ENUM_ROM_BCMD_EMSI_SDRMODE_SDR|BITM_ROM_BCMD_EMSI_BOOTENABLE;

	//4 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_4BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR|BITM_ROM_BCMD_EMSI_BOOTENABLE;


	//8 Bit SDR
	//BootCmd = (0x9<<BITP_ROM_BCMD_SPIM_DEVICE) | ENUM_ROM_BCMD_EMSI_BUSWID_8BIT | BITM_ROM_BCMD_EMSI_HISPEEDENABLE | ENUM_ROM_BCMD_EMSI_SDRMODE_SDR|BITM_ROM_BCMD_EMSI_BOOTENABLE;

	/**********************************************Boot Area*************************************************************/



	*pREG_PORTB_FER_CLR = (1 << 4);
	*pREG_PORTB_DIR_SET = (1 << 4);
	*pREG_PORTB_DATA_TGL = (1 << 4);

	adi_rom_Boot((void *)35, BITM_ROM_BFLAG_HOOK, 0, &ROM_BOOT_HOOK_FUNC1,BootCmd);  /* Boot from user area */

	//adi_rom_Boot(1, BITM_ROM_BFLAG_HOOK, 0, &ROM_BOOT_HOOK_FUNC1,BootCmd); /* Boot from boot area */

	while(1);
	return 0;
}

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{
		pBootConfig->keyType = ADI_ROM_CUSTOM_SECURITY; /*Tell ROM that we want to use custom key*/
		//pBootConfig->bootType = ADI_ROM_SECURE_BOOT;/*Secure boot*/

		uint8_t *pPublicKey  = (uint8_t *)&pBootConfig->publicKey;
#if Blx || Blw
		uint8_t *pAESKey     = (uint8_t *)&pBootConfig->aesKey;
#endif
		int i=0;
		for(i=0;i<KEY_SIZE;i++)
		{
			pPublicKey[i] = PublicKey[i];
		}

		#ifdef Blx
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESKey[i];
		}
		#endif
		#ifdef Blw
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESwrapKey[i];
			pAESKey[i] = AESKey[i];
		}
		#endif
	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{
		asm("NOP;");
	}

	return 0;
}

