/*****************************************************************************
 * ROMAPI_Boot_Core1.c
 *****************************************************************************/


#include "CustomBootMode.h"


/*Select one the macro below */
//#define BLp
//#define BLx
//#define BLw

/*Select one the macro for the authentication mode */
//#define ECDSA224
//#define ECDSA256


#ifdef ECDSA224
uint8_t PublicKey[] = {
    /* the Qx value */
    0x54, 0x79, 0xab, 0x3b,
    0xc4, 0x56, 0x08, 0x06,
    0x32, 0xe6, 0xf7, 0x83,
    0xed, 0xb9, 0xf6, 0xb9,
    0x68, 0x61, 0xea, 0xe7,
    0x36, 0x47, 0x8b, 0x91,
    0xd7, 0xfd, 0x46, 0xa4,
	0x00,0x00,0x00,0x00,

    /* the Qy value */
    0x97, 0xa5, 0x6d, 0x4b,
    0xe5, 0x45, 0x85, 0xa5,
    0x9a, 0x56, 0x8d, 0x83,
    0x09, 0xe3, 0x5f, 0x80,
    0xe1, 0x5e, 0x8c, 0x89,
    0x16, 0xb9, 0x57, 0x09,
    0xd5, 0x8e, 0xf6, 0xf1, /*CORRECT KEY*/
    //0xd5, 0x8e, 0xf6, 0xff,	/*INCORRECT KEY*/
	0x00,0x00,0x00,0x00
};
#endif
#ifdef ECDSA256
uint8_t PublicKey[] = {
    /* the Qx value */
    0x31, 0x14, 0x7d, 0xd3,
    0x76, 0x37, 0xc3, 0xd3,
    0x91, 0x00, 0x26, 0x31,
    0xed, 0x29, 0x88, 0xd0,
    0x4b, 0xa6, 0xb5, 0x69,
    0xb3, 0xbf, 0x7b, 0x4c,
    0x6b, 0xd9, 0x0f, 0x10,
    0x3e, 0xd5, 0x44, 0xa5,

    /* the Qy value */
    0xc8, 0xe1, 0xab, 0x1e,
    0x83, 0x9e, 0x2d, 0xdb,
    0xcb, 0x72, 0x75, 0x02,
    0x9a, 0xba, 0x51, 0x3a,
    0x85, 0x4b, 0x3d, 0xe4,
    0x8c, 0x0f, 0x7f, 0x98,
    0xa8, 0x7c, 0x3a, 0x38,
    0x89, 0x8b, 0x6a, 0x82 //correct
    //0x49, 0x8b, 0x6a, 0x82 //wrong

};
#endif
#ifdef BLx
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/


};
#endif
#ifdef BLw
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/

};
uint8_t AESwrapKey[]={
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/

};
#endif
ROM_BOOT_RESULT bootInitFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
ROM_BOOT_RESULT bootConfigFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
ROM_BOOT_RESULT bootLoadFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
ROM_BOOT_RESULT bootCleanUpFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);

ADI_ROM_OTP_BOOT_CGU_INFO cgu_config;
ADI_ROM_OTP_DMC_CONFIG dmc_config;

bool Result;
ADI_ROM_BOOT_CONFIG * pBootConfig_Temp;

int result = 0;
int main()
{
	adi_initComponents();

#ifdef DMC_INIT
    /*Initialize Power Service*/
    result = (uint32_t)adi_pwr_Init((uint8_t)ADI_PWR_CGU0, (uint32_t)CLKIN);
    if(result != 0)
    {
    	printf("PWR Init Failed\n");
    }

    /* Set DMC Lane Reset */
    adi_dmc_lane_reset(true);

    /* Initialize CGU and CDU */
    result = (uint32_t)adi_pwr_cfg0_init();
    if(result != 0)
    {
    	printf("PWR Config Failed\n");
    }

    /* Clear DMC Lane Reset */
    adi_dmc_lane_reset(false);

    /* Initialize DMC */
    result = adi_dmc_cfg0_init();
    if(result != 0)
    {
    	printf("DMC Config Failed\n");
    }
#endif
	ConfigSoftSwitches_EVAL_EZKIT_SOM();
	ConfigSoftSwitches_EV_SOM();

    uint32_t BootCmd=0;


	*pREG_SPU0_SECUREP147 = 0x3;
	*pREG_SPU0_SECUREP148 = 0x3;


	BootCmd = (0xF<<BITP_ROM_BCMD_SPIM_DEVICE); /*Custom Boot Support*/



    *pREG_PORTB_FER_CLR = (1 << 4);
    *pREG_PORTB_DIR_SET = (1 << 4);
    *pREG_PORTB_DATA_SET = (1 << 4);
    adi_rom_Boot(START_ADDRESS, BITM_ROM_BFLAG_HOOK, 0, &ROM_BOOT_HOOK_FUNC1,BootCmd);

	while(1);

	return 0;

}

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_REG_COMPLETE)
	{
		pBootConfig->bootRegistry.pInitFunction = (ROM_BOOT_MODE_INIT_FUNC *)bootInitFunction;
		pBootConfig->bootRegistry.pConfigFunction = (ROM_BOOT_MODE_CONFIG_FUNC *)bootConfigFunction;
		pBootConfig->bootRegistry.pLoadFunction = (ROM_BOOT_MODE_LOAD_FUNC *)bootLoadFunction;
		pBootConfig->bootRegistry.pCleanUpFunction = (ROM_BOOT_MODE_CLEANUP_FUNC *)bootCleanUpFunction;

		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{
		asm("NOP;");

		pBootConfig->keyType = ADI_ROM_CUSTOM_SECURITY; /*Tell ROM that we want to use custom key*/
//		pBootConfig->bootType = ADI_ROM_SECURE_BOOT;/*Secure boot*/

		uint8_t *pPublicKey  = &pBootConfig->publicKey;
		uint8_t *pAESKey     = (uint8_t *)&pBootConfig->aesKey;

		int i=0;
#if defined(BLp)||defined(BLx)||defined(BLw)

		for(i=0;i<64;i++)
		{
			pPublicKey[i] = PublicKey[i];
		}

#endif

		#ifdef BLx
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESKey[i];
		}

		#endif
		#ifdef BLw
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESwrapKey[i];
		}
		#endif


	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{

#if defined(BLp)||defined(BLw)||defined(BLx)
		pBootConfig->bootType = ADI_ROM_SECURE_BOOT;
		pBootConfig->pDestination = pBootConfig->pSecureHeader;
		pBootConfig->dByteCount = sizeof(SBIF_ECDSA_Header_t);
		pBootConfig->loadType = ROM_DMA_DONE_POLL_IRQDONE;
		(*(pBootConfig->bootRegistry.pLoadFunction))(pBootConfig);

#endif

	}

	return 0;
}

