/*********************************************************************************

Copyright(c) 2021 Analog Devices, Inc. All Rights Reserved.

This software is proprietary and confidential.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.

 *********************************************************************************/
/*!
* @file      adi_pwr_SC598_Family_1GHz_config.h
*
* @brief     Header file for Power Service Configuration.
*
* @details
*
*/

#ifndef ADI_PWR_SC598_FAMILY_1GHZ_CONFIG_H
#define ADI_PWR_SC598_FAMILY_1GHZ_CONFIG_H

#include <adi_types.h>

#ifdef __cplusplus
extern "C" {
#endif

uint32_t adi_pwr_cfg0_init(void) ;

/* The ratio between the core clock and the DDR clock. Used for delay cycles. */
#if defined(__ADSPCORTEXA55__)
#define cclkdclk_ratio (1.8f)
#else
#define cclkdclk_ratio (1.5f)
#endif
float32_t cclk_dclk_r(void);

#ifdef __cplusplus
}
#endif

#endif /* ADI_PWR_SC598_FAMILY_1GHZ_CONFIG_H */
