/*****************************************************************************
 * ROMAPI_Boot_Core1.c
 *****************************************************************************/


#include "CustomBootMode.h"

/*Select one the macro below */
//#define BLp
//#define BLx
//#define BLw

/*Select one the macro for the authentication mode */
//#define ECDSA224
//#define ECDSA256


#ifdef ECDSA224
uint8_t PublicKey[] = {
    /* the Qx value */
    0x54, 0x79, 0xab, 0x3b,
    0xc4, 0x56, 0x08, 0x06,
    0x32, 0xe6, 0xf7, 0x83,
    0xed, 0xb9, 0xf6, 0xb9,
    0x68, 0x61, 0xea, 0xe7,
    0x36, 0x47, 0x8b, 0x91,
    0xd7, 0xfd, 0x46, 0xa4,
	0x00,0x00,0x00,0x00,

    /* the Qy value */
    0x97, 0xa5, 0x6d, 0x4b,
    0xe5, 0x45, 0x85, 0xa5,
    0x9a, 0x56, 0x8d, 0x83,
    0x09, 0xe3, 0x5f, 0x80,
    0xe1, 0x5e, 0x8c, 0x89,
    0x16, 0xb9, 0x57, 0x09,
    0xd5, 0x8e, 0xf6, 0xf1, /*CORRECT KEY*/
    //0xd5, 0x8e, 0xf6, 0xff,	/*INCORRECT KEY*/
	0x00,0x00,0x00,0x00
};
#endif
#ifdef ECDSA256
uint8_t PublicKey[] = {
    /* the Qx value */
    0x31, 0x14, 0x7d, 0xd3,
    0x76, 0x37, 0xc3, 0xd3,
    0x91, 0x00, 0x26, 0x31,
    0xed, 0x29, 0x88, 0xd0,
    0x4b, 0xa6, 0xb5, 0x69,
    0xb3, 0xbf, 0x7b, 0x4c,
    0x6b, 0xd9, 0x0f, 0x10,
    0x3e, 0xd5, 0x44, 0xa5,

    /* the Qy value */
    0xc8, 0xe1, 0xab, 0x1e,
    0x83, 0x9e, 0x2d, 0xdb,
    0xcb, 0x72, 0x75, 0x02,
    0x9a, 0xba, 0x51, 0x3a,
    0x85, 0x4b, 0x3d, 0xe4,
    0x8c, 0x0f, 0x7f, 0x98,
    0xa8, 0x7c, 0x3a, 0x38,
    0x89, 0x8b, 0x6a, 0x82 //correct
    //0x49, 0x8b, 0x6a, 0x82 //wrong

};
#endif
#ifdef BLx
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/


};
#endif
#ifdef BLw
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/

};
uint8_t AESwrapKey[]={
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/

};
#endif


void ConfigSoftSwitches_EVAL_EZKIT_SOM(void);
void ConfigSoftSwitches_EV_SOM(void);

#if defined(__ADSPSC598_FAMILY__)
#include <cdefSC59x_rom.h>
#include <defSC59x_rom.h>
#endif

void bootInitFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootConfigFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootLoadFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);
void bootCleanUpFunction(ADI_ROM_BOOT_CONFIG * pBootConfig);


int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause) ;
ADI_ROM_OTP_BOOT_CGU_INFO cgu_config;
ADI_ROM_OTP_DMC_CONFIG dmc_config;

bool Result;
ADI_ROM_BOOT_CONFIG * pBootConfig_Temp;

/** 
 * If you want to use command program arguments, then place them in the following string. 
 */
char __argv_string[] = "";

int main(int argc, char *argv[])
{
	adi_initComponents();
    *pREG_SHL1C0_CFG2 =0x30;
    *pREG_SHL1C0_RANGE_START2 = 0x24000000 ;
    *pREG_SHL1C0_RANGE_END2 = 0x24001FFF ;

	*pREG_SHL1C0_CFG2|=0xF00 ;
	*pREG_SHL1C0_RANGE_START4 = 0x201FE000 ;
	*pREG_SHL1C0_RANGE_END4 = 0x201FFFFF ;

	asm("#include <sys/def215xx_core.h>");
	asm("IRPTL = 0;");
	asm("MMASK = BITM_REGF_MMASK_BR8|BITM_REGF_MMASK_BR0|BITM_REGF_MMASK_IRPTEN|BITM_REGF_MMASK_ALUSAT|BITM_REGF_MMASK_TRUNCATE|BITM_REGF_MMASK_PEYEN|BITM_REGF_MMASK_BDCST9|BITM_REGF_MMASK_BDCST1;");
	asm("IMASK = BITM_REGF_IMASK_EMUI|BITM_REGF_IMASK_RSTI|BITM_REGF_IMASK_PARI|BITM_REGF_IMASK_ILOPI|BITM_REGF_IMASK_CB7I|BITM_REGF_IMASK_IICDI|BITM_REGF_IMASK_SOVFI| BITM_REGF_IMASK_ILADI; nop;");
	asm("B7 = 0x201FF400;\
	              I7 = ((0x201FF400 + 0xc00 - 1)-((0x201FF400 + 0xc00 - 1) % 4) );\
	       L7 = (( 0xc00 - ((0x201FF400 + 0xc00 - 1) % 4) )/4);\
	       B6 = B7;\
	       I6 = I7; \
	        L6 = L7;");


	ConfigSoftSwitches_EVAL_EZKIT_SOM();
	ConfigSoftSwitches_EV_SOM();

    uint32_t BootCmd=0;


	*pREG_SPU0_SECUREP147 = 0x3;
	*pREG_SPU0_SECUREP148 = 0x3;

	BootCmd = (0xF<<BITP_ROM_BCMD_SPIM_DEVICE); /*Custom Boot Support*/


	/*Toggle GPIO for Boot Time Measurement*/
	*pREG_PORTB_FER_CLR = BITM_PORT_FER_PX4;
	*pREG_PORTB_DIR_SET = BITM_PORT_FER_PX4;
	*pREG_PORTB_DATA_SET = BITM_PORT_FER_PX4;

	adi_rom_Boot(START_ADDRESS, BITM_ROM_BFLAG_HOOK, 0, &ROM_BOOT_HOOK_FUNC1,BootCmd);

	while(1);

	return 0;

}

int32_t ROM_BOOT_HOOK_FUNC1(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_REG_COMPLETE)
	{
		pBootConfig->bootRegistry.pInitFunction = (ROM_BOOT_MODE_INIT_FUNC *)bootInitFunction;
		pBootConfig->bootRegistry.pConfigFunction = (ROM_BOOT_MODE_CONFIG_FUNC *)bootConfigFunction;
		pBootConfig->bootRegistry.pLoadFunction = (ROM_BOOT_MODE_LOAD_FUNC *)bootLoadFunction;
		pBootConfig->bootRegistry.pCleanUpFunction = (ROM_BOOT_MODE_CLEANUP_FUNC *)bootCleanUpFunction;

		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{
		asm("NOP;");

		pBootConfig->keyType = ADI_ROM_CUSTOM_SECURITY; /*Tell ROM that we want to use custom key*/
//		pBootConfig->bootType = ADI_ROM_SECURE_BOOT;/*Secure boot*/

		uint8_t *pPublicKey  = &pBootConfig->publicKey;
		uint8_t *pAESKey     = (uint8_t *)&pBootConfig->aesKey;

		int i=0;
#if defined(BLp)||defined(BLx)||defined(BLw)

		for(i=0;i<64;i++)
		{
			pPublicKey[i] = PublicKey[i];
		}

#endif

		#ifdef BLx
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESKey[i];
		}

		#endif
		#ifdef BLw
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESwrapKey[i];
		}
		#endif


	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{
		pBootConfig->bootBuffers.state = ADI_ROM_BOOT_BUFFERS_EMPTY;
#if defined(BLp)||defined(BLw)||defined(BLx)
		pBootConfig->bootType = ADI_ROM_SECURE_BOOT;
		pBootConfig->pDestination = pBootConfig->pSecureHeader;
		pBootConfig->dByteCount = sizeof(SBIF_ECDSA_Header_t);
		pBootConfig->loadType = ROM_DMA_DONE_POLL_IRQDONE;
		(*(pBootConfig->bootRegistry.pLoadFunction))(pBootConfig);

#endif

	}

	return 0;
}



